;
; SelfEraser v1.00.9x (WIN 9x), (c) 1999 by Dmitry Petrenko (demask@mail.ru)
;
; This sample demonstrates Over-The-Ass erasing method of the file, what
; belongs to the current process. Target OS is Win 9x. The execution of
; the last ExitThread function may cause #GP (because process was unloaded
; before), but Windoze did not say anything. So, you just have to remove
; all memory-resident debugers before usage.
;

.386p
.model flat,stdcall

        jumps

;===[ External API Declarations ]=========================================;

extrn   GlobalAlloc:proc
extrn   GetModuleHandleA:proc
extrn   GetModuleFileNameA:proc
extrn   GetProcAddress:proc
extrn   FreeLibrary:proc
extrn   MessageBoxA:proc

;===[ Data Section ]==============================================

.data

; Some constants

ofs             equ     offset
null            equ     0

; Windows API constants

GMEM_FIXED              =   0000h
GMEM_ZEROINIT           =   0040h
GPTR                    =   (GMEM_FIXED or GMEM_ZEROINIT)

MAX_SINGLEFNAME         =   256
MB_OK                   =   0

; buffer for module path and file name

box_title       db      'Self-erasing algorythm demo (Win 95), '
		db	'(x) 1999 by PREDAt0R',0
kernel_handle   dd      ?
kernel_name     db      'KERNEL32.dll',0
df_proc_name    db      'DeleteFileA',0
gf_proc_name    db      'GlobalFree',0

;===[ Code Section ]======================================================;

.code

        ; code entrypoint, stack contains ptrExitThread dword

main:
        ; allocate some memory from the global heap

        call    GlobalAlloc,GPTR,MAX_SINGLEFNAME+SelfEraserSize
        xchg    ebp,eax

        ; get module file name and path

        call    GetModuleHandleA,null
        push    eax                             ; save ptrModuleHandle
        call    GetModuleFileNameA,eax,ebp,MAX_SINGLEFNAME

        ; display our message box

        call    MessageBoxA,null,ebp,ofs box_title,\
                MB_OK

        ; get kernel32.dll module handle

        call    GetModuleHandleA,ofs kernel_name
        mov     dword ptr [kernel_handle],eax

        ; get DeleteFileA and GlobalFree addresses

        call    GetProcAddress,eax,ofs df_proc_name
        push    ebp                             ; save ptrModuleName
        push    eax                             ; save ptrDeleteFileA address
        call    GetProcAddress,[kernel_handle],ofs gf_proc_name
        push    eax                             ; save ptrGlobalFree address

        ; copy SelfEraser into allocated memory block

        xchg    edi,ebp                         ; edi == allocated mem address
        add     edi,MAX_SINGLEFNAME
        push    edi
        lea     esi,SelfEraser
        mov     ecx,SelfEraserSize/4+1
        repnz   movsd
        pop     edi
        call    edi                             ; call SelfEraser copy

;
; Main erasing routine
;

SelfEraser      proc    ptrGlobalFree,ptrDeleteFileA,ptrModuleName,\
                        ptrModuleHandle,ptrExitThread:dword

        ; unmap our module from the address space

        lea     ebx,FreeLibrary
        call    ebx,[ptrModuleHandle],0

        ; delete our module file

        call    dword ptr [ptrDeleteFileA],[ptrModuleName]

        ; discard memory block (it works, but it is not correct, so be
        ; careful while use this) and exit current thread

        push    dword ptr [ptrModuleName]
        push    dword ptr [ptrExitThread]
        jmp     dword ptr [ptrGlobalFree]

SelfEraserSize  =       $-SelfEraser

SelfEraser      endp

end main
